/**************************************************************************

                           Snap 48 Loader

**************************************************************************/

#include "emudata.h"


EmuData *TblData;
unsigned Id;

char _DSC[]=".SNA Loader v1.1b"; // ᠭ

// ப  䥩
char TxtOk[]="OK";
char TxtCancel[]="Cancel";
char TxtBrowse[]="Browse";


unsigned Key=0x0;

char Path[80];
char FileName[80];
unsigned ZVerInfo=1;



char TxtKey[]="Key:\nF7\nF8\nF9\nF10\nF11\nF12";

static const char *COffOn[]={"Off","On"};
static const char *CKey[]={"F7","F8","F9","F10","F11","F12"};

//  䨣樨
struct CnTbl CgKey={&Key,CKey,sizeof CKey/sizeof(char*)};
struct CnTbl CgVerInfo={&ZVerInfo,COffOn,sizeof COffOn/sizeof(char*)};
struct CnTxt CtFileName={FileName,80};


//  䨣樨
static struct CfgS Cfg[]={
    TTbl,"ESL_SNAL_Key=",&CgKey,
    TTbl,"ESL_SNAL_VerInfo=",&CgVerInfo,
    TTxt,"ESL_SNAL_FileName=",&CtFileName
};

struct CfgDat _CFG={Cfg,sizeof Cfg/sizeof(CfgS)}; //   䨣樨



struct _Sna48Hdr
{
    byte    I;
    word    HLa,DEa,BCa,AFa;
    word    HL,DE,BC,IY,IX;
    byte    Int;
    byte    R;
    word    AF,SP;
    byte    IntMode;
    byte    Border;
} Sna48Hdr;

//  䠩
int Handle;

//    ⭠ 祭
static const char SymHex[]={
	'0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'
};

// ॢ 祭  ப
static void HexToStr(unsigned Val,char *Txt,int Num) {
	Txt+=Num-1;
	while (Num--) {
		*Txt--=SymHex[Val&0xF];
		Val>>=4;
	}
};

// ⨥ 䠩
unsigned FileOpen(char *Name);
#pragma aux FileOpen=\
    "   mov ax,0x3d00"\
	"	xor ecx,ecx"\
	"	int 0x21"\
    "   jnc $"\
    "   neg eax"\
    "$:"\
	modify [eax ecx] parm [edx] value [eax]


//  䠩
unsigned FileCreate(char *Name);
#pragma aux FileCreate=\
	"	mov ah,0x3C"\
	"	xor ecx,ecx"\
	"	int 0x21"\
	modify [eax ecx] parm [edx] value [eax]

// ⥭ 䠩
unsigned FileRead(void *Buf,unsigned Size,unsigned Handle);
#pragma aux FileRead=\
    "   mov ah,0x3f"\
	"	int 0x21"\
    modify [eax] parm [edx][ecx][ebx] value [eax]

//  䠩
void FileSave(void *Buf,unsigned Size,unsigned Handle);
#pragma aux FileSave=\
	"	mov ah,0x40"\
	"	int 0x21"\
	modify [eax] parm [edx][ecx][ebx]

// ⨥ 䠩
void FileClose(unsigned Handle);
#pragma aux FileClose=\
	"	mov ah,0x3E"\
	"	int 0x21"\
	modify [eax] parm [ebx]

// ப  ⮪ ࠡ


void _INI(EmuData *Pnt,unsigned IdN) {
	TblData=Pnt;
	Id=IdN;
}

void _UNI() {}

/*
void _UNI() {FileClose(Handle);}
*/


void _SET() {
    void *Pnt=TblData->WinCreate(24,4,29,17,0x9F);
    TblData->WinTitle(Pnt,_DSC,0xFC);
    TblData->WinText(Pnt,6,2,"ESL, Kharkov 1997");
    TblData->SetRadio(Pnt,19,4,TxtKey,&CgKey);
    TblData->SetCheckBox(Pnt,3,4,"Show SNA\ninfo",&ZVerInfo);
    TblData->SetButton(Pnt,8,14,TxtCancel,12,0);
    TblData->SetButton(Pnt,8,12,TxtOk,12,1);
	if (TblData->WinExe(Pnt)) TblData->WinResult(Pnt);
	TblData->WinRemove(Pnt);

}



void ReadSNA(char *File)
{
    int pages[8]={1,1,0,1,1,0,1,1};  // Pages in Use
    int ErrRd=0;
    int RdLen=0;
    char mode[2][5]={" 48k","128k"};


    struct  _a
    {
        word    PC;
        byte    P7FFD;
        byte    u;
    } small;

    if ( (Handle=FileOpen( File ) ) >0 )
    {

        if ( FileRead( &Sna48Hdr, sizeof(Sna48Hdr), Handle) != sizeof(Sna48Hdr) ) ErrRd=1;

        TblData->SpecSeg[0]=TblData->SpecROM+(0x4000*1); // 48 ROM
        TblData->SpecSeg[1]=TblData->SpecRAM+(0x4000*5); // RAM PAGEs
        TblData->SpecSeg[2]=TblData->SpecRAM+(0x4000*2);
        TblData->SpecSeg[3]=TblData->SpecRAM+(0x4000*0);

        TblData->DataCPU.RegPC=0x555; // *->RETN (0xed 0x45 -> 0x72) (0xc9 -> 0xa0)

        TblData->DataCPU.RegSP=Sna48Hdr.SP;
        TblData->DataCPU.RegIX=Sna48Hdr.IX;
        TblData->DataCPU.RegIY=Sna48Hdr.IY;
        TblData->DataCPU.RegAF=Sna48Hdr.AF;
        TblData->DataCPU.RegBC=Sna48Hdr.BC;
        TblData->DataCPU.RegDE=Sna48Hdr.DE;
        TblData->DataCPU.RegHL=Sna48Hdr.HL;

        TblData->DataCPU.RegAFa=Sna48Hdr.AFa;
        TblData->DataCPU.RegBCa=Sna48Hdr.BCa;
        TblData->DataCPU.RegDEa=Sna48Hdr.DEa;
        TblData->DataCPU.RegHLa=Sna48Hdr.HLa;

        TblData->DataCPU.RegR=Sna48Hdr.R;
        TblData->DataCPU.RegI=Sna48Hdr.I;

        TblData->DataCPU.Halt=0;

        TblData->DataCPU.IFF1=(Sna48Hdr.Int & 1)<<2;
        TblData->DataCPU.IFF2=(Sna48Hdr.Int & 2)<<1;
        TblData->DataCPU.IM=Sna48Hdr.IntMode;



        TblData->Port7FFD=0x30;      // 48k Mode
        TblData->PortFE=Sna48Hdr.Border;

        TblData->IntWait=0; //  뢠
        TblData->IntLast=0; // ᫥ 맮 _INT  ⮬ 뢠


        if ( FileRead( TblData->SpecSeg[1] , 16384 , Handle) != 16384 ) ErrRd=1;
        if ( FileRead( TblData->SpecSeg[2] , 16384 , Handle) != 16384 ) ErrRd=1;
        if ( FileRead( TblData->SpecSeg[3] , 16384 , Handle) != 16384 ) ErrRd=1;

        if ( (RdLen=FileRead( &small,sizeof(small),Handle)) == sizeof(small) )
        {

            int p=small.P7FFD & 7;

            TblData->SpecSeg[3]=TblData->SpecRAM+(0x4000*p); // map page

            pages[p]=0;

            if ( p )
            {
                unsigned char *src=TblData->SpecROM+(0x4000*0);
                unsigned char *dst=TblData->SpecROM+(0x4000*p);
                for (int i=0;i<16384;i++ ) *dst++=*src++;
            }
            for ( int i=0;i<8;i++ )
            {
                if ( pages[i] )
                 if ( FileRead( TblData->SpecRAM+(0x4000*i) , 16384 , Handle) != 16384 ) ErrRd=1;
            }
        } // 128k snapshot

        FileClose(Handle);

        if ( ErrRd )
        {
            TblData->DataCPU.RegPC=0; // Reset if Read error
            TblData->MessageBox(0x4f,"Read ERROR, reset in 48k mode.","");
        }
        else
        {
            if ( RdLen )
            {
                RdLen=1;                           // 128k mode read OK
                TblData->Port7FFD=small.P7FFD;
                TblData->DataCPU.RegPC=small.PC;
            }
            if (ZVerInfo) TblData->MessageBox(0x9f,mode[RdLen]," SnapShot loaded.");
        } // ErrRd

    }
    else
    {
        TblData->MessageBox(0x4f,"ERROR open file :",FileName);
    } // FileOpen Error


}


void GetPath(char *src,char *dst)
{
    char *SlPos=dst;
    *dst=0;

    while ( *src )
    {
        if ( *src == '\\' ) SlPos=dst+1;
        *dst++=*src++;
    }
    *SlPos=0;
}

void MakeFullName(char *Name,char *Path)
{
    char *src;
    char *dst;
    int Dflag=0;

    src=Name;
    while ( *src ) if ( (*src++) == ':' ) Dflag = !0;

    if ( !Dflag )
    {
        src=Path; dst=Name;
        while ( *Path++ );
        Path--;
        while ( *Name ) *Path++=*Name++;
        *Path=0;
        while ( *src ) *dst++=*src++;
        *dst=0;
    }
}

static void WorkMenu() {

    int Result=-1;

    TblData->TextMode();

    void *Pnt=TblData->WinCreate(8,6,63,12,0x9F);
    TblData->WinTitle(Pnt,_DSC,0xF4);

        TblData->WinText(Pnt,2,2," 48k/128k .SNA file loader by ESL. Kharkov, Ukraine, 1997.");
        TblData->WinText(Pnt,2,3,"                   FidoNet: 2:461/108.7");

//        TblData->WinText(Pnt,4,5,"File name");

        void *TxtPnt=TblData->SetInputTxt(Pnt,4,6,35,"File Name",&CtFileName);

        TblData->SetCheckBox(Pnt,20,5,"Show .SNA info",&ZVerInfo);


        TblData->SetButton(Pnt,44,7,TxtBrowse,12,3);

        TblData->SetButton(Pnt,29,9,TxtCancel,12,0);
        TblData->SetButton(Pnt,13,9,TxtOk,12,1);

    while ( (Result != 0) && (Result != 1) )
    {

        GetPath(FileName,Path);

        if ( (Result=TblData->WinExe(Pnt)) == 3) TblData->FileBox(TxtPnt,"*.sna",Path);
        TblData->WinResult(Pnt);
        if (*Path) MakeFullName(FileName,Path);

    }

    TblData->WinRemove(Pnt);

    if ( Result )
    {
        if ( *FileName ) ReadSNA(FileName);
    }

    TblData->SetSpec();
}

void _F7_() {if (Key==0) WorkMenu();}
void _F8_() {if (Key==1) WorkMenu();}
void _F9_() {if (Key==2) WorkMenu();}
void _F10() {if (Key==3) WorkMenu();}
void _F11() {if (Key==4) WorkMenu();}
void _F12() {if (Key==5) WorkMenu();}

