        BITS    16
        ORG     0x100

        SECTION .text

        jmp     start
New21:
        cmp     ah,30h
        jnz     n1
        jmp     CheckOVR
n1:
        cmp     byte [cs:OnFlag],1
        jnz     Run21

        cmp     ah,3dh  ; Open File
        jz      MyOpen

        cmp     ah,3eh  ; Close File
        jz      MyClose

Run21:
        jmp     far [cs:Old21]

MyClose:
        pusha
        push    ds
        call    FixCRC
        pop     ds
        popa
        jmp     Run21

MyOpen:
        pusha
        push    ds
        push    es

        push    ds
        push    dx      ; Name
        pop     bx
        pop     es

ScanLP:
        mov     al,[es:bx]
        cmp     al,0
        jz      RetMO
        cmp     al,'.'
        jz      Found1
        inc     bx
        jmp     ScanLP
Found1:
        inc     bx
        mov     al,[es:bx]
        and     al,5fh
        cmp     al,'T'
        jnz     RetMO
        inc     bx
        mov     al,[es:bx]
        and     al,5fh
        cmp     al,'D'
        jnz     RetMO
        dec     bx
        mov     byte [es:bx],'Z'
        pusha

        mov     bx,dx
        mov     di,Name

CopyLP:
        mov     al,[ds:bx]
        mov     [cs:di],al
        inc     bx
        inc     di
        cmp     al,0
        jnz     CopyLP
        dec     di
        mov     byte [cs:di],'$'

        mov     ah,3ch
        mov     cx,0

        call    T21

        jc      CreatErr
        mov     word [cs:Handle],ax
        popa
        mov     byte [es:bx],'T'
CreatErr:

RetMO:
        pop     es
        pop     ds
        popa
;        call    far [cs:Old21]
;        mov     word [cs:PHandle],ax
;        retf
        jmp     Run21

T21:
        mov     byte [cs:OnFlag],0
        int     21h
        mov     byte [cs:OnFlag],1
        ret

CheckOVR:
        push    ds
        push    bx
        push    bp
        mov     bp,sp
        lds     bx,[ss:bp+6]
        mov     bx,[ds:0b8h]
        mov     ds,bx
        cmp     byte [ds:09adh],07eh
        jnz     FailOVR
        cmp     byte [ds:09cbh],080h
        jnz     FailOVR
        cmp     byte [ds:0a13h],0ffh
        jnz     FailOVR
        mov     byte [cs:OnFlag],1

;        mov     byte [ds:09a1h],0eah
;        mov     word [ds:09a2h],TStart
;        mov     word [ds:09a4h],cs

        mov     byte [ds:0a5ah],0eah
        mov     word [ds:0a5bh],TEnd
        mov     word [ds:0a5dh],cs

;        mov     [cs:TSeg1],ds
        mov     [cs:TSeg2],ds

        jmp     RetCHK
FailOVR:
        lds     bx,[ss:bp+6]
        mov     byte [ds:bx+0],0b4h     ; mov ah,4ch; int 21h
        mov     byte [ds:bx+1],04ch
        mov     byte [ds:bx+2],0cdh
        mov     byte [ds:bx+3],021h
RetCHK:
        pop     bp
        pop     bx
        pop     ds

        jmp     Run21

FixCRC:
        mov     ax,4200h                ;Seek
        mov     bx,word [cs:Handle]
        xor     cx,cx
        xor     dx,dx
        call    T21

        mov     ah,3fh
        mov     bx,word [cs:Handle]
        mov     cx,12
        push    cs
        pop     ds
        mov     dx,CRCBuf
        call    T21

;ds:si   - src
;cx      - len

        push    cs
        pop     ds

        mov     si,CRCBuf
        mov     cx,10

        mov     byte [ds:si+0],'T'
        mov     byte [ds:si+1],'D'

        cld
        xor     dx, dx
CRCLoop:
        lodsb
        xor     al, dh
        mov     bl, al
        xor     bh, bh
        lea     bx, [cs:bx+CRCTab]
        mov     al, [cs:bx]
        xor     al, dl
        mov     dh, al
        inc     bh
        mov     dl, [cs:bx]
        loop    CRCLoop

        mov     [cs:CRCBuf+10],dx

        mov     ax,4200h                ;Seek
        mov     bx,word [cs:Handle]
        xor     cx,cx
        xor     dx,dx
        call    T21

        mov     ah,40h                  ;Write
        mov     bx,word [cs:Handle]
        mov     cx,12
        push    cs
        pop     ds
        mov     dx,CRCBuf
        call    T21

        mov     ah,3eh                  ;Close
        mov     bx,word [cs:Handle]
        call    T21
        ret

TEnd:
        pusha
        mov     ax,4000h
        mov     bx,[cs:Handle]
        mov     cx,[bp+0ah]
        mov     ds,[bp+8]
        mov     dx,[bp+6]
        call    T21
        popa

        pop     ds
        pop     si
        pop     di
        mov     sp,bp

        db      0eah
        dw      0a5fh
TSeg2:  dw      0


start:
        mov     sp,stack

        mov     dx,mHello
        mov     ah,9
        int     21H

        mov     dx,mUsage
        xor     cx,cx
        mov     cl,[080h]

        cmp     cx,0
        jz      MsgExit2

        mov     si,081h
        mov     dx,mErrWild

ScanLoop:
        cmp     byte [si],'?'
        jz      MsgExit2
        cmp     byte [si],'*'
        jz      MsgExit2
        inc     si
        loop    ScanLoop

Start2:

        mov     ax,cs
        mov     es,ax
        mov     ah,4ah          ; es - seg !!!
        mov     bx,1000h
        int     21h             ; resize mem

; Get I21
        mov     ax,3521h
        int     21h
        mov     [I21Off],bx
        mov     [I21Seg],es
; Set I21
        mov     ax,2521h
        push    cs
        pop     ds
        mov     dx,New21
        int     21h

; Exec
        mov     bp,sp
        push    cs
        push    word 6ch        ; PSP FCB2
        push    cs
        push    word 5ch        ; PSP FCB1
        push    cs
        push    word 80h        ; PSP CmdLine
        push    word 0

        mov     dx,OvrName
        mov     bx,sp
        push    cs
        push    cs
        pop     ds
        pop     es
        mov     ax,4b00h
        int     21h
        mov     sp,bp


        mov     dx,mErrOvr
        jc      MsgExit

; Normal Exit

        mov     dx,mWrongOvr
        cmp     byte [cs:OnFlag],0
        jz      MsgExit

        mov     dx,mOk

MsgExit:

; Restore I21
        push    dx
        mov     ax,[cs:I21Seg]
        mov     ds,ax
        mov     dx,[cs:I21Off]
        mov     ax,2521h
        int     21h
        pop     dx
;
MsgExit2:
        push    cs
        pop     ds
        mov     ah,9
        int     21h
        mov     dx,mCrLf
        mov     ah,9
        int     21h
exit:
        mov     ax,4c00h
        int     21h

        SECTION .data
                db 13,10,'Compiled use NASM 097',13,10
mHello          db 'TeleDisk .td? file Unpacker v 2.0 by Sergey Erokhin. (04 Oct 98)',13,10,'$'
mOk             db '  TDUNP: Create File: '
Name            db 13,"  TDUNP:  ! Error: Can't open file$"
                times   60     db      0
mUsage          db '  TDUNP:  Usage: TDUNP FileName.Ext$'
mErrOvr         db '  TDUNP:  ! Error: load TDCHECK.EXE, aborting ...$'
mWrongOvr       db '  TDUNP:  ! Error: wrong overlay code, aborting ...$'
mErrWild        db '  TDUNP:  ! Error: No ? and * in filename, aborting ...$'
mCrLf           db 13,10,'$'

Old21           equ     $
I21Off          dw      0
I21Seg          dw      0

OnFlag:         db      0
Handle:         dw      0
PHandle:        dw      0
CRCBuf:         times   12      db      0

OvrName         db 'tdcheck.exe',0

CRCTab          db 0, 0A0h, 0E1h, 41h, 63h, 0C3h, 82h
		db 22h,	0C7h, 67h, 26h,	86h, 0A4h, 4
		db 45h,	0E5h, 2Fh, 8Fh,	0CEh, 6Eh, 4Ch
		db 0ECh, 0ADh, 0Dh, 0E8h, 48h, 9, 0A9h
		db 8Bh,	2Bh, 6Ah, 0CAh,	5Eh, 0FEh, 0BFh
		db 1Fh,	3Dh, 9Dh, 0DCh,	7Ch, 99h, 39h
		db 78h,	0D8h, 0FAh, 5Ah, 1Bh, 0BBh, 71h
		db 0D1h, 90h, 30h, 12h,	0B2h, 0F3h, 53h
		db 0B6h, 16h, 57h, 0F7h, 0D5h, 75h, 34h
		db 94h,	0BCh, 1Ch, 5Dh,	0FDh, 0DFh, 7Fh
		db 3Eh,	9Eh, 7Bh, 0DBh,	9Ah, 3Ah, 18h
		db 0B8h, 0F9h, 59h, 93h, 33h, 72h, 0D2h
		db 0F0h, 50h, 11h, 0B1h, 54h, 0F4h, 0B5h
		db 15h,	37h, 97h, 0D6h,	76h, 0E2h, 42h
		db 3, 0A3h, 81h, 21h, 60h, 0C0h, 25h
		db 85h,	0C4h, 64h, 46h,	0E6h, 0A7h, 7
		db 0CDh, 6Dh, 2Ch, 8Ch,	0AEh, 0Eh, 4Fh
		db 0EFh, 0Ah, 0AAh, 0EBh, 4Bh, 69h, 0C9h
		db 88h,	28h, 0D8h, 78h,	39h, 99h, 0BBh
		db 1Bh,	5Ah, 0FAh, 1Fh,	0BFh, 0FEh, 5Eh
		db 7Ch,	0DCh, 9Dh, 3Dh,	0F7h, 57h, 16h
		db 0B6h, 94h, 34h, 75h,	0D5h, 30h, 90h
		db 0D1h, 71h, 53h, 0F3h, 0B2h, 12h, 86h
		db 26h,	67h, 0C7h, 0E5h, 45h, 4, 0A4h
		db 41h,	0E1h, 0A0h, 0, 22h, 82h, 0C3h
		db 63h,	0A9h, 9, 48h, 0E8h, 0CAh, 6Ah
		db 2Bh,	8Bh, 6Eh, 0CEh,	8Fh, 2Fh, 0Dh
		db 0ADh, 0ECh, 4Ch, 64h, 0C4h, 85h, 25h
		db 7, 0A7h, 0E6h, 46h, 0A3h, 3,	42h
		db 0E2h, 0C0h, 60h, 21h, 81h, 4Bh, 0EBh
		db 0AAh, 0Ah, 28h, 88h,	0C9h, 69h, 8Ch
		db 2Ch,	6Dh, 0CDh, 0EFh, 4Fh, 0Eh, 0AEh
		db 3Ah,	9Ah, 0DBh, 7Bh,	59h, 0F9h, 0B8h
		db 18h,	0FDh, 5Dh, 1Ch,	0BCh, 9Eh, 3Eh
		db 7Fh,	0DFh, 15h, 0B5h, 0F4h, 54h, 76h
		db 0D6h, 97h, 37h, 0D2h, 72h, 33h, 93h
		db 0B1h, 11h, 50h, 0F0h, 0, 97h, 0B9h
		db 2Eh,	0E5h, 72h, 5Ch,	0CBh, 0CAh, 5Dh
		db 73h,	0E4h, 2Fh, 0B8h, 96h, 1, 3
		db 94h,	0BAh, 2Dh, 0E6h, 71h, 5Fh, 0C8h
		db 0C9h, 5Eh, 70h, 0E7h, 2Ch, 0BBh, 95h
		db 2, 6, 91h, 0BFh, 28h, 0E3h, 74h
		db 5Ah,	0CDh, 0CCh, 5Bh, 75h, 0E2h, 29h
		db 0BEh, 90h, 7, 5, 92h, 0BCh, 2Bh
		db 0E0h, 77h, 59h, 0CEh, 0CFh, 58h, 76h
		db 0E1h, 2Ah, 0BDh, 93h, 4, 0Ch, 9Bh
		db 0B5h, 22h, 0E9h, 7Eh, 50h, 0C7h, 0C6h
		db 51h,	7Fh, 0E8h, 23h,	0B4h, 9Ah, 0Dh
		db 0Fh,	98h, 0B6h, 21h,	0EAh, 7Dh, 53h
		db 0C4h, 0C5h, 52h, 7Ch, 0EBh, 20h, 0B7h
		db 99h,	0Eh, 0Ah, 9Dh, 0B3h, 24h, 0EFh
		db 78h,	56h, 0C1h, 0C0h, 57h, 79h, 0EEh
		db 25h,	0B2h, 9Ch, 0Bh,	9, 9Eh,	0B0h
		db 27h,	0ECh, 7Bh, 55h,	0C2h, 0C3h, 54h
		db 7Ah,	0EDh, 26h, 0B1h, 9Fh, 8, 8Fh
		db 18h,	36h, 0A1h, 6Ah,	0FDh, 0D3h, 44h
		db 45h,	0D2h, 0FCh, 6Bh, 0A0h, 37h, 19h
		db 8Eh,	8Ch, 1Bh, 35h, 0A2h, 69h, 0FEh
		db 0D0h, 47h, 46h, 0D1h, 0FFh, 68h, 0A3h
		db 34h,	1Ah, 8Dh, 89h, 1Eh, 30h, 0A7h
		db 6Ch,	0FBh, 0D5h, 42h, 43h, 0D4h, 0FAh
		db 6Dh,	0A6h, 31h, 1Fh,	88h, 8Ah, 1Dh
		db 33h,	0A4h, 6Fh, 0F8h, 0D6h, 41h, 40h
		db 0D7h, 0F9h, 6Eh, 0A5h, 32h, 1Ch, 8Bh
		db 83h,	14h, 3Ah, 0ADh,	66h, 0F1h, 0DFh
		db 48h,	49h, 0DEh, 0F0h, 67h, 0ACh, 3Bh
		db 15h,	82h, 80h, 17h, 39h, 0AEh, 65h
		db 0F2h, 0DCh, 4Bh, 4Ah, 0DDh, 0F3h, 64h
		db 0AFh, 38h, 16h, 81h,	85h, 12h, 3Ch
		db 0ABh, 60h, 0F7h, 0D9h, 4Eh, 4Fh, 0D8h
		db 0F6h, 61h, 0AAh, 3Dh, 13h, 84h, 86h
		db 11h,	3Fh, 0A8h, 63h,	0F4h, 0DAh, 4Dh
		db 4Ch,	0DBh, 0F5h, 62h, 0A9h, 3Eh, 10h
		db 87h

                times 100h db 0
stack      equ $
