/**************************************************************************

                           .Z80 Loader

**************************************************************************/

#include "emudata.h"


EmuData *TblData;
unsigned Id;

unsigned Key=1;
unsigned AutoLoad=0;
unsigned ZVerInfo=1;
char FileName[80]="";


char _DSC[]=".Z80 Loader v1.1b"; // ᠭ

#define Title _DSC
// char Title[]=".Z80 Loader v1.01 beta"; // ᠭ

// ப  䥩
char TxtOk[]="OK";
char TxtCancel[]="Cancel";
char TxtBrowse[]="Browse";

char TxtKey[]="Key:\nF7\nF8\nF9\nF10\nF11\nF12";

// ப  䨣樨
static const char *COffOn[]={"Off","On"};
static const char *CKey[]={"F7","F8","F9","F10","F11","F12"};

//  䨣樨
struct CnTbl CgAutoLoad={&AutoLoad,COffOn,sizeof COffOn/sizeof(char*)};
struct CnTbl CgVerInfo={&ZVerInfo,COffOn,sizeof COffOn/sizeof(char*)};
struct CnTbl CgKey={&Key,CKey,sizeof CKey/sizeof(char*)};
struct CnTxt CtFileName={FileName,80};


//  䨣樨
static struct CfgS Cfg[]={
    TTbl,"ESL_Z80L_AutoLoad=",&CgAutoLoad,
    TTbl,"ESL_Z80L_VerInfo=",&CgVerInfo,
    TTbl,"ESL_Z80L_Key=",&CgKey,
    TTxt,"ESL_Z80L_FileName=",&CtFileName
};

struct CfgDat _CFG={Cfg,sizeof Cfg/sizeof(CfgS)}; //   䨣樨



unsigned NewFileFlag=1;
int ErrRd=0;
int TxtMode=0;

char Path[80];



struct _Z80_1
{
    byte    A;
    byte    F;
    word    BC;
    word    HL;
    word    PC;
    word    SP;
    byte    I;
    byte    R;

    byte    F0; //
//    unsigned R_7:0x1;           //Bit 0  : Bit 7 of the R-register
//    unsigned Border:0x3;        //Bit 1-3: Border colour
//    unsigned SROM:0x1;          //1=Basic SamRom switched in
//    unsigned CompFlag:0x1;      //1=Block of data is compressed

    word    DE;
    word    BCa;
    word    DEa;
    word    HLa;
    byte    Aa;
    byte    Fa;
    word    IY;
    word    IX;
    byte    IFF1;               // Interrupt flipflop, 0=DI, otherwise EI
    byte    IFF2;               // IFF2 (not particularly important...)
    byte    F1;
//    byteIntMode:0x2;       // Bit 0-1: Interrupt mode (0, 1 or 2)
//    unsigned I2E:0x1;           // Bit 2  : 1=Issue 2 emulation
//    unsigned Dfrq:0x1;          // Bit 3  : 1=Double interrupt frequency
//    unsigned Vsync:0x2;         // Bit 4-5: 1=High vid sync, 3=Low vid sync, 0,2=Normal
//    unsigned JoyType:0x2;       //Bit 6-7: 0=Cursor/Protek/AGF joystick

} Z80_H1;

struct _Z80_2
{
    word    Add_Len;    //Len of add hdr (23-V2.01)(54-V3.0)
    word    PC;         //Program counter
    byte    HardMode;   //Hardware mode
//:0 - 48k
//:1 - 48k + If.1
//:2 - SamRam
//:3 - 128k
//:4 -  128k + If.1

    byte    P7FFD;      //port 7ffd
    byte    I1;         //Contains 0FF if Interface I rom paged
    byte    FL2;
//:00000001  if R register emulation on,
//:00000010  1 if LDIR emulation on
    byte    RegIndex;   //Last OUT to fffd (soundchip register number)
    byte    AY[16];     //Contents of the sound chip registers
} Z80_H2;

struct _Z80_3
{
    word   Lt;//       Low T state counter
    byte   Ht;//       Hi T state counter
    byte   QL;//       Flag byte used by Spectator (QL spec. emulator), Ignored by Z80 when loading, zero when saving
    byte   MGTR;//     0FF if MGT Rom paged
    byte   MR;//       0FF if Multiface Rom paged. Should always be 0.
    byte   Ram0;//     0FF if 0-8191 is RAM
    byte   Ram1;//     0FF if 8192-16383 is RAM
    byte   Key0[10];// 5x keyboard mappings for user defined joystick
    byte   Key1[10];// 5x ascii word: keys corresponding to mappings above
    byte   Mgtt;//     MGT type: 0=Disciple+Epson,1=Discipls+HP,16=Plus D
    byte   Dsc1;//     Disciple inhibit button status: 0=out, 0ff=in
    byte   Dsc2;//     Disciple inhibit flag: 0=rom pageable, 0ff=not
//    byte   unk; //     ?????????
} Z80_H3;

//  䠩
int Handle;

//    ⭠ 祭
static const char SymHex[]={
	'0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'
};

// ॢ 祭  ப
static void HexToStr(unsigned Val,char *Txt,int Num) {
	Txt+=Num-1;
	while (Num--) {
		*Txt--=SymHex[Val&0xF];
		Val>>=4;
	}
};

// ⨥ 䠩
unsigned FileOpen(char *Name);
#pragma aux FileOpen=\
    "   mov ax,0x3d00"\
	"	xor ecx,ecx"\
	"	int 0x21"\
    "   jnc $"\
    "   neg eax"\
    "$:"\
	modify [eax ecx] parm [edx] value [eax]


//  䠩
unsigned FileCreate(char *Name);
#pragma aux FileCreate=\
	"	mov ah,0x3C"\
	"	xor ecx,ecx"\
	"	int 0x21"\
	modify [eax ecx] parm [edx] value [eax]

// ⥭ 䠩
unsigned FileRead(void *Buf,unsigned Size,unsigned Handle);
#pragma aux FileRead=\
    "   mov ah,0x3f"\
	"	int 0x21"\
    modify [eax] parm [edx][ecx][ebx] value [eax]

//  䠩
void FileSave(void *Buf,unsigned Size,unsigned Handle);
#pragma aux FileSave=\
	"	mov ah,0x40"\
	"	int 0x21"\
	modify [eax] parm [edx][ecx][ebx]

// ⨥ 䠩
void FileClose(unsigned Handle);
#pragma aux FileClose=\
	"	mov ah,0x3E"\
	"	int 0x21"\
	modify [eax] parm [ebx]

byte GetByte(void)
{

    byte    *buf=TblData->SpecRAM+(0x4000*0x3f);
    static    word    bptr=16384;

    if ( ( bptr == 16384 ) || NewFileFlag )
    {
       FileRead(buf,16384,Handle);
       bptr=0;
       NewFileFlag=0;
    }
    return buf[bptr++];
}

void PutByte(word addr,byte b)
{
    (TblData->SpecSeg[addr>>0xE])[addr&0x3FFF]=b;
}


void Z80Read48( word dst)
{
    byte    last=255,c1,c2,len;
    int     curr;
    int     exit=0;
    word    ccc=0;

    for(;;)
    {
        c1=GetByte();
        if ( c1 == 0xed )
        {
            c2=GetByte();
            if ( c2 == 0xed)
            {
                len=GetByte();
                if ( ( len == 0 ) && ( last == 0 ) ) break;
                c1=GetByte();
                len--;

                while(len)
                {
                    PutByte(dst++,c1);
                    len--;
                    ccc++;
                }
            }
            else
            {
                PutByte(dst++,c1);
                ccc++;
                c1=c2;
            }
        }
        PutByte(dst++,c1);
        ccc++;
        last=c1;
    }
}

void Z80Read128(byte *dst,int ImgLen)
{
    byte    *src=TblData->SpecRAM+(0x4000*0x30);
    byte    *end;
    byte    len;

    end=src+ImgLen;

    if ( FileRead(src,ImgLen,Handle) != ImgLen ) ErrRd=1;

    byte    c1,c2;
    word    ccc=0;

    while ( src < end )
    {
        c1=*src++;
        if ( c1 == 0xed )
        {
            c2=*src++;
            if ( c2 == 0xed)
            {
                len=*src++;
                c1=*src++;
                len--;

                while(len)
                {
                    *dst++=c1;
                    len--;
                }
            }
            else
            {
                *dst++=c1;
                c1=c2;
            }
        } // C1 == 0xed
        *dst++=c1;
    } // While Src<End
}


void ReadZ80(char *File)
{
    int RdLen=0;
    byte version=0;
    char Cver[3][5]={"1.45","2.01","3.0"};
 //                    0  1  2  3  4  5  6  7  8  9 10 11
    byte map[2][12]={{10,10,10,10, 2, 0,10,10, 5,10,10,10}, // 48K Mode
                     {10,10,10, 0, 1, 2, 3, 4, 5, 6, 7,10}};    // 128k Mode

    byte HType[2][7]={{0,0,0,1,1,0,0},{0,0,0,1,1,1,1}}; // 0 48/ 1 128

    struct _CompHdr
    {
        word    Len;
        byte    Page;
    } CmpHdr;


    if ( (Handle=FileOpen( File ) ) >0 )
    {

        if ( FileRead( &Z80_H1, sizeof(Z80_H1), Handle) != sizeof(Z80_H1) ) ErrRd=1;

        TblData->SpecSeg[0]=TblData->SpecROM+(0x4000*1); // 48 ROM
        TblData->SpecSeg[1]=TblData->SpecRAM+(0x4000*5); // RAM PAGEs
        TblData->SpecSeg[2]=TblData->SpecRAM+(0x4000*2);
        TblData->SpecSeg[3]=TblData->SpecRAM+(0x4000*0);

        TblData->DataCPU.RegPC=Z80_H1.PC;// 0x4a6;//
        TblData->DataCPU.RegSP=Z80_H1.SP;
        TblData->DataCPU.RegIX=Z80_H1.IX;
        TblData->DataCPU.RegIY=Z80_H1.IY;

        TblData->DataCPU.RegA=Z80_H1.A;
        TblData->DataCPU.RegF=Z80_H1.F;

        TblData->DataCPU.RegBC=Z80_H1.BC;
        TblData->DataCPU.RegDE=Z80_H1.DE;
        TblData->DataCPU.RegHL=Z80_H1.HL;

        TblData->DataCPU.RegAa=Z80_H1.Aa;
        TblData->DataCPU.RegFa=Z80_H1.Fa;
        TblData->DataCPU.RegBCa=Z80_H1.BCa;
        TblData->DataCPU.RegDEa=Z80_H1.DEa;
        TblData->DataCPU.RegHLa=Z80_H1.HLa;

        TblData->DataCPU.RegR=Z80_H1.R | (Z80_H1.F0 & 1)<<7;
        TblData->DataCPU.RegI=Z80_H1.I;

        TblData->DataCPU.Halt=0;

        TblData->DataCPU.IFF1=(Z80_H1.IFF1)?4:0;
        TblData->DataCPU.IFF2=(Z80_H1.IFF2)?4:0;
        TblData->DataCPU.IM=Z80_H1.F1 & 3; //IntMode;

        TblData->PortFE=(Z80_H1.F0 >> 1) & 7;

        TblData->Port7FFD=0x30;      // 48k Mode

        TblData->IntWait=0; //  뢠
        TblData->IntLast=0; // ᫥ 맮 _INT  ⮬ 뢠


        if ( Z80_H1.PC == 0 )
        {
            version=1;
            if ( FileRead( &Z80_H2, sizeof(Z80_H2), Handle) != sizeof(Z80_H2) ) ErrRd=1;
            if ( Z80_H2.Add_Len != 23 )
            {
                if (Z80_H2.Add_Len != 54)  ErrRd = 1;
                if ( FileRead( &Z80_H3, sizeof(Z80_H3), Handle) != sizeof(Z80_H3) ) ErrRd=1;
                version=2;
            }
        }

        if ( version == 0 )
        {                                       // 48 k only
            if (Z80_H1.F0 && 0x10 /*CompFlag*/ )
            {
                Z80Read48( 0x4000 );
            } // compress
            else
            {
                if ( FileRead( TblData->SpecSeg[1] , 16384 , Handle) != 16384 ) ErrRd=1;
                if ( FileRead( TblData->SpecSeg[2] , 16384 , Handle) != 16384 ) ErrRd=1;
                if ( FileRead( TblData->SpecSeg[3] , 16384 , Handle) != 16384 ) ErrRd=1;
            } // no compress

            // ShutDown AY
            for ( int i=0;i<0x10;i++ ) TblData->AY.RegData[i]=0;
            TblData->AY.RegIndex=0;

        } // version 0
        else
        {                               // 48 & 128 k
            int mod=HType[(version>0)?1:0][Z80_H2.HardMode]; // 0 - 48, 1 -128

            while ( FileRead( &CmpHdr , sizeof(CmpHdr) , Handle) == sizeof(CmpHdr) )
            {
                Z80Read128(TblData->SpecRAM+(0x4000*map[mod][CmpHdr.Page]) , CmpHdr.Len);
            }
            if ( mod ) // 128k Mode
            {
                TblData->SpecSeg[3]=TblData->SpecRAM+(0x4000*(Z80_H2.P7FFD & 7)); // map page
                TblData->Port7FFD=Z80_H2.P7FFD;

                // Restore AY
                for ( int i=0;i<0x10;i++ )
                {
                    TblData->AY.RegData[i]=(mod)?Z80_H2.AY[i]:0;
                }
                TblData->AY.RegIndex=(mod)?Z80_H2.RegIndex:0;
            }

            TblData->DataCPU.RegPC=Z80_H2.PC;

        } // mode 1&2


        if ( ErrRd )
        {
            TblData->DataCPU.RegPC=0; // Reset if Read error
            TblData->MessageBox(0x4f,"Read ERROR, reset in 48k mode.","");
        }
        else
        {
            if (ZVerInfo) TblData->MessageBox(0x9f,".Z80 Version ",Cver[version]);
        } // ErrRd

        FileClose(Handle);
    }
    else
    {
        TblData->MessageBox(0x4f,"ERROR open file :",FileName);
    } // FileOpen Error

}


void GetPath(char *src,char *dst)
{
    char *SlPos=dst;
    *dst=0;

    while ( *src )
    {
        if ( *src == '\\' ) SlPos=dst+1;
        *dst++=*src++;
    }
    *SlPos=0;
}

void MakeFullName(char *Name,char *Path)
{
    char *src;
    char *dst;
    int Dflag=0;

    src=Name;
    while ( *src ) if ( (*src++) == ':' ) Dflag = !0;

    if ( !Dflag )
    {
        src=Path; dst=Name;
        while ( *Path++ );
        Path--;
        while ( *Name ) *Path++=*Name++;
        *Path=0;
        while ( *src ) *dst++=*src++;
        *dst=0;
    }
}



void _INI(EmuData *Pnt,unsigned IdN) {

//!!!!!!!!!!!!!!!!!!!!!!!!!!
//    _DSC[KEYOFF]='7'+Key;
//!!!!!!!!!!!!!!!!!!!!!!!!!!

    TblData=Pnt;
	Id=IdN;
}

void _UNI() {}


static void WorkMenu() {

    int Result=-1;

    NewFileFlag=1;
    ErrRd=0;

    TblData->TextMode();

    void *Pnt=TblData->WinCreate(8,5,63,13,0x9F);
    TblData->WinTitle(Pnt,Title,0xF4);

    TblData->WinText(Pnt,2,2,"    Z80 file loader by ESL. Kharkov, Ukraine, 1997.");
    TblData->WinText(Pnt,2,3,"                   FidoNet: 2:461/108.7");


    TblData->SetButton(Pnt,44,8,TxtBrowse,12,3);

    void *TxtPnt=TblData->SetInputTxt(Pnt,4,7,35,"File Name",&CtFileName);


    TblData->SetCheckBox(Pnt,33,5,"Show .Z80 version info",&ZVerInfo);

    TblData->SetCheckBox(Pnt,5,5,"Auto Load",&AutoLoad);

    TblData->SetButton(Pnt,33,10,TxtCancel,12,0);
    TblData->SetButton(Pnt,13,10,TxtOk,12,1);

    while ( (Result != 0) && (Result != 1) )
    {

        GetPath(FileName,Path);

        if ( (Result=TblData->WinExe(Pnt)) == 3) TblData->FileBox(TxtPnt,"*.z80",Path);
        TblData->WinResult(Pnt);
        if (*Path) MakeFullName(FileName,Path);
    }

    TblData->WinRemove(Pnt);


    if ( Result )
    {
        if ( *FileName ) ReadZ80(FileName);
    }

    TblData->SetSpec();

}

void _SET() {
    void *Pnt=TblData->WinCreate(24,4,29,17,0x9F);
    TblData->WinTitle(Pnt,Title,0xFC);
    TblData->WinText(Pnt,6,2,"ESL, Kharkov 1997");
    TblData->SetRadio(Pnt,19,4,TxtKey,&CgKey);
    TblData->SetCheckBox(Pnt,3,7,"Auto Load",&AutoLoad);
    TblData->SetCheckBox(Pnt,3,4,"Show Z80\nver.info",&ZVerInfo);
    TblData->SetButton(Pnt,8,14,TxtCancel,12,0);
    TblData->SetButton(Pnt,8,12,TxtOk,12,1);



    if (TblData->WinExe(Pnt)) TblData->WinResult(Pnt);

//!!!!!!!!!!!!!!!!!!!!!!!!!!
//    _DSC[KEYOFF]  =CKey[Key][1];
//    _DSC[KEYOFF+1]=CKey[Key][2];
//!!!!!!!!!!!!!!!!!!!!!!!!!!

	TblData->WinRemove(Pnt);

}

void _RES()
{
        if (  (*FileName) && AutoLoad )
        {
            TblData->TextMode();
            ReadZ80(FileName);
            TblData->SetSpec();
        }
}

void _F7_() {if (Key==0) WorkMenu();}
void _F8_() {if (Key==1) WorkMenu();}
void _F9_() {if (Key==2) WorkMenu();}
void _F10() {if (Key==3) WorkMenu();}
void _F11() {if (Key==4) WorkMenu();}
void _F12() {if (Key==5) WorkMenu();}

